zoukankan      html  css  js  c++  java
  • bzoj3887: [Usaco2015 Jan]Grass Cownoisseur

    题意:

    给一个有向图,然后选一条路径起点终点都为1的路径出来,有一次机会可以沿某条边逆方向走,问最多有多少个点可以被经过?(一个点在路径中无论出现多少正整数次对答案的贡献均为1)

    =>有向图我们先考虑缩点。然后观察缩点后的图可以发现新的路径中必定只有一条边是反向的才符合条件。那么我们可以联想到某道最短路的题将边反向存一遍后分别从s和t跑一跑。那么这里bfs跑一跑就行了。然后有一个坑点:这种重建图的注意es和edges不然es会在中途就被修改掉了。。。 

    #include<cstdio>
    #include<cstring>
    #include<cctype>
    #include<algorithm>
    #include<queue>
    #include<stack>
    using namespace std;
    #define rep(i,s,t) for(int i=s;i<=t;i++)
    #define dwn(i,s,t) for(int i=s;i>=t;i--)
    #define clr(x,c) memset(x,c,sizeof(x))
    #define qwq(x) for(edge *o=head[x];o;o=o->next)
    #define qaq(x) for(edge *o=hd[x];o;o=o->next)
    #define TAT(x) for(edge *o=eo[x];o;o=o->next)
    int read(){
    	int x=0;char c=getchar();
    	while(!isdigit(c)) c=getchar();
    	while(isdigit(c)) x=x*10+c-'0',c=getchar();
    	return x;
    }
    const int nmax=1e5+5;
    const int inf=0x7f7f7f7f;
    
    struct edge{
    	int to;edge *next;
    };edge es[nmax],edges[nmax<<1],*pt=es,*head[nmax],*hd[nmax],*eo[nmax];
    void add(int u,int v){
    	pt->to=v;pt->next=head[u];head[u]=pt++;
    }
    void adde(int u,int v){
    	pt->to=v;pt->next=hd[u];hd[u]=pt++;
    	pt->to=u;pt->next=eo[v];eo[v]=pt++;
    }
    int pre[nmax],dfs_clock=0,scc_cnt=0,sccno[nmax],sm[nmax];
    stack<int>s;
    int dfs(int x){
    	int lowu=pre[x]=++dfs_clock;s.push(x);
    	qwq(x){
    		if(!pre[o->to]) lowu=min(lowu,dfs(o->to));
    		else if(!sccno[o->to]) lowu=min(lowu,pre[o->to]);
    	}
    	if(lowu==pre[x]){
    		++scc_cnt;int tc=0;
    		while(1){
    			int tx=s.top();s.pop();
    			sccno[tx]=scc_cnt;++tc;
    			if(x==tx) break;
    		}
    		sm[scc_cnt]=tc;
    	}
    	return lowu;
    }
    
    queue<int>q;bool vis[nmax];int f[nmax],g[nmax];
    int test_cnt=0;
    void bfs1(int x){
    	q.push(x);f[x]=sm[x];int tx;clr(vis,0);
    	while(!q.empty()){
    		tx=q.front();q.pop();vis[tx]=0;
    		qaq(tx) if(f[o->to]<f[tx]+sm[o->to]){
    			f[o->to]=f[tx]+sm[o->to];
    			if(!vis[o->to]) q.push(o->to),vis[o->to]=1;
    		}
    	}
    }
    void bfs2(int x){
    	q.push(x);g[x]=sm[x];int tx;clr(vis,0);
    	while(!q.empty()){
    		tx=q.front();q.pop();vis[tx]=0;
    		TAT(tx) if(g[o->to]<g[tx]+sm[o->to]){
    			g[o->to]=g[tx]+sm[o->to];
    			if(!vis[o->to]) q.push(o->to),vis[o->to]=1;
    		}
    	}
    }
    
    int main(){
    	int n=read(),m=read(),u,v;
    	rep(i,1,m) u=read(),v=read(),add(u,v);
    	rep(i,1,n) if(!pre[i]) dfs(i);
    	//rep(i,1,n) printf("%d ",sccno[i]);printf("
    ");
    	
    	pt=edges;
    	rep(i,1,n) qwq(i) if(sccno[i]!=sccno[o->to]) adde(sccno[i],sccno[o->to]);
    	bfs1(sccno[1]);bfs2(sccno[1]);
    	//rep(i,1,scc_cnt) printf("%d %d
    ",f[i],g[i]);
    	
    	int ans=sm[sccno[1]];
    	rep(i,1,scc_cnt) qaq(i) {
    		if(g[i]&&f[o->to]) ans=max(ans,g[i]+f[o->to]-sm[sccno[1]]);
    	}
    	printf("%d
    ",ans);return 0;
    }
    

      

    3887: [Usaco2015 Jan]Grass Cownoisseur

    Time Limit: 10 Sec  Memory Limit: 128 MB
    Submit: 179  Solved: 92
    [Submit][Status][Discuss]

    Description

    In an effort to better manage the grazing patterns of his cows, Farmer John has installed one-way cow paths all over his farm. The farm consists of N fields, conveniently numbered 1..N, with each one-way cow path connecting a pair of fields. For example, if a path connects from field X to field Y, then cows are allowed to travel from X to Y but not from Y to X. Bessie the cow, as we all know, enjoys eating grass from as many fields as possible. She always starts in field 1 at the beginning of the day and visits a sequence of fields, returning to field 1 at the end of the day. She tries to maximize the number of distinct fields along her route, since she gets to eat the grass in each one (if she visits a field multiple times, she only eats the grass there once). As one might imagine, Bessie is not particularly happy about the one-way restriction on FJ's paths, since this will likely reduce the number of distinct fields she can possibly visit along her daily route. She wonders how much grass she will be able to eat if she breaks the rules and follows up to one path in the wrong direction. Please compute the maximum number of distinct fields she can visit along a route starting and ending at field 1, where she can follow up to one path along the route in the wrong direction. Bessie can only travel backwards at most once in her journey. In particular, she cannot even take the same path backwards twice.
    给一个有向图,然后选一条路径起点终点都为1的路径出来,有一次机会可以沿某条边逆方向走,问最多有多少个点可以被经过?(一个点在路径中无论出现多少正整数次对答案的贡献均为1)

    Input

    The first line of input contains N and M, giving the number of fields and the number of one-way paths (1 <= N, M <= 100,000). The following M lines each describe a one-way cow path. Each line contains two distinct field numbers X and Y, corresponding to a cow path from X to Y. The same cow path will never appear more than once.

    Output

    A single line indicating the maximum number of distinct fields Bessie
    can visit along a route starting and ending at field 1, given that she can
    follow at most one path along this route in the wrong direction.
     

    Sample Input

    7 10
    1 2
    3 1
    2 5
    2 4
    3 7
    3 5
    3 6
    6 5
    7 2
    4 7

    Sample Output

    6

    HINT

     

    Source

  • 相关阅读:
    Week2实验 B--爆零(❌)大力出奇迹(√) HDU
    Windows10家庭版安装Docker(不是DockerToolbox)
    Ubuntu搭建DNS服务器遇到的问题1
    Ubuntu执行apt-get时遇到的问题1
    Windows2000下vc++6.0编译出现“Error spawning cl.exe”
    win2000安装官方发布的最后一个补丁KB891861
    Windows2000密钥
    Linux下使用gets和puts方法出现的错误
    执行.sh文件调用变量时出现“未找到命令”
    SQL Server2012无法连接到服务器
  • 原文地址:https://www.cnblogs.com/fighting-to-the-end/p/6036575.html
Copyright © 2011-2022 走看看